function Query(sql, cb) {
  this._sql = sql;
  this._cb = cb;
  this._callSite = new Error();
}

Query.prototype.execute = function() {
  process.nextTick(this._cb);
};

function Connection() {
  this._queue = [];
}

Connection.prototype.query = function(sql, cb) {
  var self = this;
  var query = new Query(sql, function() {
    self._queue.shift();
    cb();
  });
  self._queue.push(query);
  query.execute();
};

var connection  = new Connection();
var sql = 'SELECT 0';

var start = Date.now();
function query() {
  var usage = process.memoryUsage().heapUsed / 1024 / 1024;
  console.log(usage);
  var duration = Date.now()-start;
  if (usage > 50) {
    console.log('leak detected: memory usage > 50 MB, took: %d sec', duration/1000);
    process.exit(1);
  }

  if (duration > 5000) {
    console.log('no leak detected after 5 sec');
    process.exit(0);
  }

  connection.query(sql, function(err, rows) {
    query();
  });
};

query();
